#ifndef __REMODELSEARCH_H
#define __REMODELSEARCH_H

class Config;
class DoubleDatabase;
class TranslationRule;
struct TranslationStats;
class TranslationTable;
class CandidateRule;

#include <Bass.h>

class RemodelSearch {
public:
	RemodelSearch();
	virtual ~RemodelSearch();

	/* ---- Basic get/set ---- */

	/* ---- Init & perform search ---- */
	int getMilliCount();
	int getMilliSpan(int nTimeStart);
	virtual void				Init(DoubleDatabase *ddb);
	virtual TranslationTable*	MineThatTable() =0;

	/* ---- The Factory ---- */
	static RemodelSearch*		Create(const string &searchName, Config *config);

protected:
	// Helpers
	void						ProgressToScreen(const uint64 curCandidate, const uint64 total);

	void						OpenProgressFile();
	void						ProgressToFileAddRule(TranslationRule *rule, const uint64 candId, TranslationStats &stats, int time_ms);
	void						ProgressToFileCandidate(CandidateRule *rule, const uint64 candId);
	void						CloseProgressFile();

	// Members
	DoubleDatabase*				mDDB;
	uint16						mProgress;

private:
	FILE						*mProgressFile;
};

#endif // __REMODELSEARCH_H
