#ifndef __RULETREE_H
#define __RULETREE_H

class Pair;
class RuleNode;
class TranslationRule;
class TranslationTable;
enum ItemSetType;

class RuleTree {
public:
	RuleTree(TranslationTable *tt, Uint16ItemSet **items, uint16 *alph2Item, uint16 *item2Alph, Pair **pairs, const uint32 numPairs, ItemSetType dataType);
	~RuleTree();

	void			SetMinSup(const uint32 minSup)		{ mMinSup = minSup; }
	
	TranslationRule *MineBestRule(float &gain);

protected:
	// Settings
	uint32				mMinSup;

	// Members owned by RuleTree
	float**				mRowPotentials;
	float*				mItemPotentials;

	ItemSetType			mDataType;		

	// Members not owned by RuleTree
	TranslationTable*	mTT;
	Uint16ItemSet**		mItems;
	uint16*				mAlph2Item;
	uint16*				mItem2Alph;
	Pair**				mPairs;
	uint32				mNumPairs;

	friend class RuleNode;
};

#endif // __RULETREE_H
